/*******************************************************************************
 *  EVSE-template.h - MSP430F6736 distribution version
 *
 * Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/ 
 * ALL RIGHTS RESERVED 
 *
 ******************************************************************************/

/* Define the current rating of the EVSE hardware (in Amps). This is converted
   to a PWM for the pilot signal. Software currently only supports 0-51Amps */
#define CURRENT_RATING                      15

/* States for EVSE state machine */
typedef enum {
	STARTUP,
	GFCI_CHECK_START,
	GFCI_CHECK_EXPECTED,
	GFCI_PASSED,
	FAULT,
	STATE_A,
	STATE_B,
	STATE_C,
	STATE_D,
	STATE_E,
	STATE_F
}EVSE_states_enum;

/* Potential EVSE fault conditions */
typedef enum {
	GFCI_FAULT,
	GFCI_CHECK_FAULT,
	RELAY_FAULT,
	PILOT_FAULT,
	VOLTAGE_FAULT,
	GENERIC_FAULT
}fault_conditions;
