/*******************************************************************************
 *  metrology-callbacks.h -
 *
 * Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/ 
 * ALL RIGHTS RESERVED 
 *
 ******************************************************************************/

/*! \file */

#if !defined(_METROLOGY_CALLBACKS_H_)
#define _METROLOGY_CALLBACKS_H_

#if defined(__cplusplus)
extern "C"
{
#endif

int energy_update(int ph, int type, energy_t amount);

#if defined(TOTAL_ACTIVE_ENERGY_PULSES_PER_KW_HOUR)  ||  defined(ACTIVE_ENERGY_PULSES_PER_KW_HOUR) \
    || \
    defined(TOTAL_REACTIVE_ENERGY_PULSES_PER_KVAR_HOUR)  ||  defined(REACTIVE_ENERGY_PULSES_PER_KVAR_HOUR) \
    || \
    defined(TOTAL_APPARENT_ENERGY_PULSES_PER_KVAR_HOUR)  ||  defined(APPARENT_ENERGY_PULSES_PER_KVAR_HOUR)
void energy_pulse_start(int ph, int which);
void energy_pulse_end(int ph, int which);
#endif

#if defined(SAG_SWELL_SUPPORT)
/* This callback routine is called with one of the following event codes
         2 = The swell condition has continued for another mains cycle
         1 = Onset of the swell condition
         0 = The voltage has returned to normal
        -1 = Onset of the sag condition
        -2 = The sag condition has continued for another mains cycle */

enum
{
    SAG_SWELL_VOLTAGE_POWER_DOWN_SAG = -3,
    SAG_SWELL_VOLTAGE_SAG_CONTINUING = -2,
    SAG_SWELL_VOLTAGE_SAG_ONSET = -1,
    SAG_SWELL_VOLTAGE_NORMAL = 0,
    SAG_SWELL_VOLTAGE_SWELL_ONSET = 1,
    SAG_SWELL_VOLTAGE_SWELL_CONTINUING = 2,
    SAG_SWELL_VOLTAGE_POWER_DOWN_OK = 3
};

void sag_swell_event(int ph, int event);
#endif

#if defined(__cplusplus)
}
#endif

#endif
