/*******************************************************************************
 *  flash_memcpy.c - Flash memory copy routines.
 *
 * Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/ 
 * ALL RIGHTS RESERVED 
 *
 ******************************************************************************/

#include <signal.h>
#include <inttypes.h>
#if defined(__MSP430__)
#include <msp430.h>
#endif
#include "emeter-toolkit.h"

#if defined(__MSP430__)
void flash_memcpy(char *ptr, char *from, int len)
{
    _DINT();
    FCTL3 = FWKEY;                      /* Lock = 0 */
    FCTL1 = FWKEY | WRT;
    while (len)
    {
        *ptr++ = *from++;
        len--;
    }
}
#endif
