/*******************************************************************************
 *  flash_write_int16.c - Flash write 16 bit routines.
 *
 * Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/ 
 * ALL RIGHTS RESERVED 
 *
 ******************************************************************************/

#include <signal.h>
#include <inttypes.h>
#if defined(__MSP430__)
#include <msp430.h>
#endif
#include "emeter-toolkit.h"

#if defined(__MSP430__)
void flash_write_int16(int16_t *ptr, int16_t value)
{
    _DINT();
    FCTL3 = FWKEY;                      /* Lock = 0 */
    FCTL1 = FWKEY | WRT;
    *((int16_t *) ptr) = value;         /* Program the flash */
}
#endif
