/*******************************************************************************
 *  shift48.c - Shift a 48 bit number left or right.
 *
 * Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/ 
 * ALL RIGHTS RESERVED 
 *
 ******************************************************************************/

#include <inttypes.h>
#include "emeter-toolkit.h"

void shift48(int16_t x[3], int how_far)
{
#if !defined(__MSP430__)
    int64_t tmp;
#endif

    if (how_far < 0)
    {
        while (how_far++)
        {
#if defined(__GNUC__)  &&  defined(__MSP430__)
            __asm__ __volatile__ (
                " rra 4(%[x]) \n"
                " rrc 2(%[x]) \n"
                " rrc 0(%[x]) \n"
                : [x] "+r"(x)
                : );
#else
            tmp = x[2];
            tmp = tmp << 16;
            tmp |= x[1];
            tmp = tmp << 16;
            tmp |= x[0];
            tmp >>= 1;
            x[2] = (tmp >> 32) & 0xFFFF;
            x[1] = (tmp >> 16) & 0xFFFF;
            x[0] = tmp & 0xFFFF;
#endif
        }
    }
    else
    {
        while (how_far--)
        {
#if defined(__GNUC__)  &&  defined(__MSP430__)
            __asm__ __volatile__ (
                " rla 0(%[x]) \n"
                " rlc 2(%[x]) \n"
                " rlc 4(%[x]) \n"
                : [x] "+r"(x)
                : );
#else
            tmp = x[2];
            tmp = tmp << 16;
            tmp |= x[1];
            tmp = tmp << 16;
            tmp |= x[0];
            tmp <<= 1;
            x[2] = (tmp >> 32) & 0xFFFF;
            x[1] = (tmp >> 16) & 0xFFFF;
            x[0] = tmp & 0xFFFF;
#endif
        }
    }
}
